;-----------------------------------------------------------------------------
;--------- ** Sunshine's OpCode 0.8 ** ---------------------------------------

; Well here it is, the outstanding PEStuff DLL Example in MASM.

; In fact, this tool is some kind of opgen clone (by Neural Noise).
; The idea came to me cause opgen doesn't always work for me (there are
; sometimes file-mapping errors) and it's a really useful tool :-). Enjoy it!

; Note that this is the basic example to show the use of PEStuff DLL.
; There is also a version of this tool with some nicer layout and the
; possibility to save the list to a file.

; E-Mail: Ligthen-Sunrise@gmx.de
; WEB : www.sunshine2k.de || www.sunshine.2kx.de
; Sunshine, February 2k4
;-----------------------------------------------------------------------------


.386
.model stdcall, flat
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comdlg32.inc 
include \masm32\include\gdi32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comdlg32.lib 
includelib \masm32\lib\gdi32.lib

;--------------------------------------------------------------
;---- Forward declarations of functions -----------------------
;--------------------------------------------------------------

DlgProc proto :DWORD,:DWORD,:DWORD,:DWORD
LBAdd proto : LPSTR


;--------------------------------------------------------------
;---- Variables and Constants ---------------------------------
;--------------------------------------------------------------

.data

;-- ** Error Strings ** ---------------------------------------
errCouldNotFindDll db "Could not load PEStuff.dll. Aborting...",0
errCap db "Error",0
errFunctionNotFound db "Could not locate function in dll",13,10, \
                    "Is this the right PEStuff.dll?",0
errMapFile db "Mapping the file to memory failed. Aborting...",0
errPE db "File seems not to be a valid PE file. Aborting...",0
errImpTable db "File has no Import Table!",0
errNoImports db "Could not find any imports... :-(",0
errImportInfo db "Getting Import Table Information failed!",0
errValuesfromDll db "Getting information of imported function failed!",0


myfilterstring db "PE Files (.exe, .dll)",0,"*.exe;*.dll",0,"All Files",0,"*.*",0,0
abouttext db "Opcode 0.8 (MASM Example for using PEStuff DLL)",13,10,13,10,\
             "www.sunshine2k.de",13,10,"Sunshine, February 2k4",0
aboutcap db "About...",0

;-- ** Names of used functions from PEStuff DLL ** ------------
PeStuffdllname db "PEStuff.dll",0
mapfile db "MapFile",0
isValidPE db "IsValidPE",0
unMapFile db "UnMapFile",0
getNumberOfImportedDlls db "GetNumberOfImportedDlls",0 
checkImportTable db "CheckImportTable",0
getImportDescriptor db "GetImportDescriptor",0
getNumberOfFunctionsFromDll db "GetNumberOfFunctionsFromDll",0
getValuesfromDll db "GetValuesfromDll",0

;-- ** some strings for formatting ** -------------------------
fstrdllname db "Name of DLL : %s",0
formatstr2 db "Number of Dlls imported: %d (hex: %02X)",0
fstrFuncs db "Number of imported functions: %d",0
fstropcode db "%s = call dword ptr[%08X]",0
space db " ",0
LBfont db "Courier New",0

;-- ** Addresses of functions from PEStuff ** ------------------
MapFileAddr DWORD 0
IsValidPEAddr DWORD 0
UnMapFileAddr DWORD 0
GetNumberOfImportedDllsAddr DWORD 0
CheckImportTableAddr DWORD 0
GetImportDescriptorAddr DWORD 0
GetNumberOfFunctionsFromDllAddr DWORD 0
GetValuesfromDllAddr DWORD 0

pMap LPVOID 0     	; store pointer to our mapped file in memory

hLB HANDLE 0      	; store listbox handle
CountDlls DWORD 0 	; store how many dlls mapped file imports
CountFuncs DWORD 0	; store how many functions from one specific dll are imported
ImageBase DWORD 0       ; store ImageBase (needed for opcode calculation)

dllcounter DWORD 0      ; counter variable for looping through every dll
functioncounter DWORD 0 ; counter for looping through all function from one dll


.data?
ofn OPENFILENAME <>	; openfilename structure
hInstance HANDLE ?

; ** Variables for GetImportDescriptor call **
dllname LPSTR ?
OriFirstThunk db ?
TimeDateStamp dd ?
ForwarderChain dd ?
DllNameRVA dd ?
FirstThunk dd ? 

; ** Variables for GetValuesfromDll call **
ThunkRVA dd ?
ThunkOffset dd ?
ThunkValue dd ?
Hint dd ?
ThunkApiName dd ?

hfont HFONT ?		; handle for listbox font

hDll HANDLE ?		; return value of LoadLibrary
bufout LPSTR ?
buffer db ?


;--------------------------------------------------------------
;---- Code starts here ----------------------------------------
;--------------------------------------------------------------

.code

start:
   invoke GetModuleHandle, 0
   mov hInstance, eax
   invoke DialogBoxParamA, hInstance, 101, NULL, addr DlgProc, NULL
   invoke ExitProcess, eax



;--------------------------------------------------------------
;---- DLPROC : MAIN MESSAGE LOOP ------------------------------
;--------------------------------------------------------------

DlgProc proc hwnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
  .IF uMsg==WM_DESTROY
      invoke EndDialog, hwnd, NULL
      
  ;-----------------------------------------------
  ;-------- WM_INITDIALOG ---------------------
  ;----------------------------------------------- 
  .ELSEIF uMsg==WM_INITDIALOG
      ; ** load PEStuff library
      invoke LoadLibrary, addr PeStuffdllname
      mov hDll, eax
      .IF hDll==0
         invoke MessageBox, hwnd, addr errCouldNotFindDll, addr errCap, MB_OK
         invoke EndDialog, hwnd, 0
      .ENDIF
      
      ; ** get addresses of all needed functions
      invoke GetProcAddress, hDll, addr mapfile
      mov MapFileAddr, eax
      
      invoke GetProcAddress, hDll, addr isValidPE
      mov IsValidPEAddr, eax
      
      invoke GetProcAddress, hDll, addr unMapFile
      mov UnMapFileAddr, eax
      
      invoke GetProcAddress, hDll, addr getNumberOfImportedDlls
      mov GetNumberOfImportedDllsAddr, eax
      
      invoke GetProcAddress, hDll, addr checkImportTable
      mov CheckImportTableAddr, eax
      
      invoke GetProcAddress, hDll, addr getImportDescriptor
      mov GetImportDescriptorAddr, eax
      
      invoke GetProcAddress, hDll, addr getNumberOfFunctionsFromDll
      mov GetNumberOfFunctionsFromDllAddr, eax
      
      invoke GetProcAddress, hDll, addr getValuesfromDll
      mov GetValuesfromDllAddr, eax
      
      ; ** check if all functions addresses could be located
      .IF MapFileAddr==0 || IsValidPEAddr==0 || UnMapFileAddr==0 || GetNumberOfImportedDllsAddr==0 \
                         || CheckImportTableAddr==0 || GetImportDescriptorAddr==0 \
                         || GetNumberOfFunctionsFromDllAddr==0 || GetValuesfromDllAddr==0
         invoke MessageBox, hwnd, addr errFunctionNotFound, addr errCap, MB_OK
         invoke EndDialog, hwnd, 0
      .ENDIF
      
      ; ** get handle of listbox
      invoke GetDlgItem, hwnd, 10
      mov hLB, eax
      
      ; ** Create font and assign it to listbox
      invoke CreateFont, -11, 0, 0, 0, 0, 0, 0, 0, DEFAULT_CHARSET,OUT_TT_PRECIS, \
      	                 CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, FF_MODERN, addr LBfont
   
      ; ** if font is created successfully, assign it to listbox
      .IF eax!=0
          mov hfont, eax
          invoke SendMessage, hLB, WM_SETFONT, hfont, TRUE
      .ENDIF
      
      

  .ELSEIF uMsg==WM_COMMAND
    mov eax, wParam
    
    ;-----------------------------------------------
    ;-------- OPEN FILE Button ---------------------
    ;-----------------------------------------------
    .IF ax==1
      shr eax,16
	  .IF ax==BN_CLICKED
	  
	  ; ** initialize OPENFILENAME structure
	  mov ofn.lStructSize, SIZEOF ofn
	  mov ofn.lpstrFilter, offset myfilterstring
	  mov ofn.lpstrFile, offset buffer
	  mov ofn.nMaxFile, 512
	  mov ofn.Flags, OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or\
	                 OFN_EXPLORER or OFN_HIDEREADONLY
	  invoke GetOpenFileName, ADDR ofn
	  .IF eax==TRUE
	  
	     ; ** first of all, we clear listbox in case it's not empty
@LBDelMore:  invoke SendMessage, hLB, LB_GETCOUNT, 0, 0
             cmp eax,0
	     jz @LBEmpty
	     
	     invoke SendMessage, hLB, LB_DELETESTRING, 0, 0
	     jmp @LBDelMore
	     
	     
@LBEmpty:    ; ** map file to memory
	     push offset buffer
	     call MapFileAddr
	     mov pMap, eax
	     .IF eax==0
	         invoke MessageBox, hwnd, addr errMapFile, errCap, MB_OK
	         mov eax, FALSE
	         ret
	     .ENDIF    
	     
	     ; ** Check for valid PE **
	     push pMap
	     call IsValidPEAddr
	     .IF eax==FALSE
	         invoke MessageBox, hwnd, addr errPE, addr errCap, MB_OK
	         mov eax,FALSE
	         ret
	     .ENDIF
	     
	     ; ** Get ImageBase (we'll need it later) **
	     mov eax, [pMap]
	     add eax, 03Ch
	     mov ebx, [eax]
	     mov eax, [pMap]
	     add eax, ebx
	     add eax, 034h
	     mov eax, [eax]
	     mov ImageBase, eax
	     
	     ; ** Check if file has Import Table **
	     push pMap
	     call CheckImportTableAddr
	     .IF eax==FALSE
	         invoke MessageBox, hwnd, addr errImpTable, addr errCap, MB_OK
		 mov eax,FALSE
		 ret
	     .ENDIF
	     
	     ; ** Get Number of imported dlls **
	     push pMap
	     call GetNumberOfImportedDllsAddr
	     mov CountDlls, eax
	     .IF eax==0
	     	 invoke MessageBox, hwnd, addr errNoImports, addr errCap, MB_OK
	     	 mov eax,FALSE
	     	 ret
	     .ENDIF
	     
	     
	     ; ---- Insert some information into listbox ----
	     
	     ; ** insert filename **
	     invoke LBAdd, addr buffer ;filename
	     ; ** insert number of dlls **
	     invoke wsprintf, addr bufout, addr formatstr2, CountDlls, CountDlls
	     invoke LBAdd, addr bufout
	     invoke LBAdd, addr space
	     
	     mov dllcounter, 0
@loopDLL:    inc dllcounter
	     	     
	     ; ** Call GetImportDescriptor for first dll **
	     push offset FirstThunk
	     push offset DllNameRVA
	     push offset ForwarderChain
	     push offset TimeDateStamp
	     push offset OriFirstThunk
	     push offset dllname
	     push dllcounter
	     push pMap
	     call GetImportDescriptorAddr
	     .IF eax==FALSE
	         invoke MessageBox, hwnd, addr errImportInfo, addr errCap, MB_OK
		 mov eax,FALSE	
		 ret
	     .ENDIF
	     
	     invoke LBAdd, addr space
	     invoke wsprintf, addr bufout, addr fstrdllname, dllname
	     invoke LBAdd, addr bufout
	     
	     ; ** Get number of functions from first dll **
	     
	     push dllcounter
	     push pMap
	     call GetNumberOfFunctionsFromDllAddr
	     mov CountFuncs, eax
	     
	     invoke wsprintf, addr bufout, addr fstrFuncs, CountFuncs
	     invoke LBAdd, addr bufout
	     invoke LBAdd, addr space
	     
	     
	     mov functioncounter, 0
	     
 @loopfuncs: inc functioncounter
             
                          
             mov ThunkApiName, 0
             mov Hint, 0
             mov ThunkValue, 0
             mov ThunkOffset, 0
             mov ThunkRVA, 0
             
             
             push offset ThunkApiName
             push offset Hint
             push offset ThunkValue
             push offset ThunkOffset
             push offset ThunkRVA
             push functioncounter
             push dllcounter
             push pMap
             call GetValuesfromDllAddr
             .IF eax==FALSE
	     	         invoke MessageBox, hwnd, addr errValuesfromDll, addr errCap, MB_OK
	     		 mov eax,FALSE	
	     		 ret
	     .ENDIF
	     
	     ; ** calculate opcode
	     xor ebx,ebx
	     add ebx, ImageBase
	     add ebx, FirstThunk
	     mov eax,functioncounter
	     mov edx,4
	     mul edx
	     add ebx,eax
	     sub ebx,4
	     invoke wsprintf, addr bufout, addr fstropcode, ThunkApiName, ebx
	     invoke LBAdd, addr bufout
	     
	     ; ** check if there is more to do
	     mov edx, functioncounter
	     cmp edx, CountFuncs
	     jne @loopfuncs
	     
	     ; ** check if finished all dlls or not...
	     mov esi, dllcounter
	     mov eax, CountDlls
	     cmp esi, eax
	     jne @loopDLL


             
             ; ** ok we are finished so clean up	     
	     push pMap
	     call UnMapFileAddr
	     
	     ; ** clear filename buffer otherwise the next call to GetOpenFileName will fail (strange...)
	     invoke RtlZeroMemory, addr buffer, SIZEOF buffer
	     
	  .ENDIF 
            
        .ENDIF ; end of BN_CLICKED
        
        
    ;-----------------------------------------
    ;-------- About Button -------------------
    ;-----------------------------------------

    .ELSEIF ax==2
        shr eax,16
	  .IF ax==BN_CLICKED
            invoke MessageBox, hwnd, addr abouttext, addr aboutcap, MB_ICONINFORMATION
        .ENDIF
    .ENDIF        

         
  .ELSEIF uMsg==WM_CLOSE
        invoke EndDialog, hwnd, 0
             

  .ELSEIF
      mov eax, FALSE
      ret
  .ENDIF
  mov eax, TRUE
  ret



DlgProc endp


;--------------------------------------------------------
;-- Help function for inserting a string into listbox ---
;--------------------------------------------------------

LBAdd proc uses eax buf:LPSTR

  invoke SendMessage, hLB, LB_INSERTSTRING, -1, buf
  ret
  
LBAdd endp



end start